Compiler subclass: #LCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Compiler'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

LCompiler class
	instanceVariableNames: ''!

!LCompiler class methodsFor: 'accessing' stamp: 'bolot 7/2/1999 17:25'!
parserClass
	"Return a parser class to use for parsing method headers."

	^LParser! !


Collection subclass: #List
	instanceVariableNames: 'content link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Compiler'!

!List methodsFor: 'testing' stamp: 'mt 6/30/1999 12:00'!
isEmpty
    ^false! !

!List methodsFor: 'testing' stamp: 'bolot 8/4/1999 18:04'!
isLastNode
        "Answer true if receiver's link contains
         an EmptyList."
    ^link class == EmptyList or: [(link isKindOf: List) not]! !


!List methodsFor: 'adding' stamp: 'mt 6/30/1999 12:00'!
addList: aList
    link class == EmptyList
        ifTrue: [
            link := aList]
        ifFalse: [
            (link isKindOf: List)
                ifTrue: [link addList: aList]
                ifFalse: [self error: 'can''t add to non-list']].
    ^aList! !

!List methodsFor: 'adding' stamp: 'mt 6/30/1999 12:00'!
add: anObject
    link class == EmptyList
        ifTrue: [
            link := List with: anObject]
        ifFalse: [
            (link isKindOf: List)
                ifTrue: [link add: anObject]
                ifFalse: [self error: 'can''t add to non-list']].
    ^anObject! !


!List methodsFor: 'enumerating' stamp: 'mt 6/30/1999 12:00'!
do: aBlock
        "Answer the receiver.  For each element in the receiver,
         evaluate aBlock with that element as the argument."
    | aNode |
    aNode := self.
    [aBlock value: aNode head.
     aNode := aNode tail.
     (aNode isKindOf: List) ifFalse: [^self].
     aNode isEmpty]
        whileFalse: []! !


!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
at: anInteger
        "Answer the element at the position anInteger."
    | answer |
    anInteger < 1
        ifTrue: [self error: 'index less than 1'].
    anInteger = 1
        ifTrue: [^content]
        ifFalse: [
            self isLastNode
                ifFalse: [^link at: anInteger - 1]
                ifTrue: [self error: 'out of range']]! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
head
    ^content! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
head: anObject
    content := anObject! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
size
    ^1 +
        ((link isKindOf: List)
            ifTrue: [link size]
            ifFalse: [0])! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
tail
    ^link! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
tail: anObject
    link := anObject! !


!List methodsFor: 'printing' stamp: 'mt 6/30/1999 12:00'!
printOne: aStream
    content printOn: aStream.
    aStream nextPut: $ .
    (link isKindOf: List)
        ifTrue: [link printOne: aStream]
        ifFalse: [
            aStream nextPutAll: '| '.
            link printOn: aStream]! !

!List methodsFor: 'printing' stamp: 'mt 6/30/1999 12:00'!
printOn: aStream
    aStream nextPut: $[.
    self printOne: aStream.
    aStream nextPut: $]! !


!List methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 20:49'!
includes: anObject 
"SH: 2004/11/21 BugFix"

	(self head == anObject) 
		ifTrue: [^ true.]
		ifFalse: [^ self tail includes: anObject.].! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

List class
	instanceVariableNames: ''!

!List class methodsFor: 'instance creation' stamp: 'bolot 7/28/1999 15:31'!
fromBraceStack: itsSize 
	"Answer an instance of me with itsSize elements, popped in reverse order from
	 the stack of thisContext sender.  Do not call directly: this is called by {1. 2. 3}
	 constructs."

	^((Array new: itsSize) fill: itsSize fromStack: thisContext sender) asList! !

!List class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
head: aObject tail: bObject
    ^self basicNew
        head: aObject;
        tail: bObject;
        yourself! !

!List class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
new
    ^EmptyList new! !

!List class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
with: anObject
    ^self basicNew
        head: anObject;
        tail: EmptyList new! !

!List class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
with: anObject with: bObject
    ^self basicNew
        head: anObject;
        tail: (List with: bObject)! !


List subclass: #EmptyList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Compiler'!

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
add: anObject
    | aList |
    aList := List with: anObject.
    aList become: self.
    ^aList! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
do: aBlock
    ^self! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
head
        "Error, empty list does not have head."
    ^self error: 'Message not understood: head'! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
isEmpty
    ^true! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
printOne: aStream
        "Print nothing."! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
size
    ^0! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
tail
        "Error, empty list does not have tail."
    ^self error: 'Message not understood: tail'! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
= anObject
    ^anObject class == EmptyList! !


!EmptyList methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 20:49'!
includes: anObject 
"SH: 2004/11/21 BugFix"

	^ false.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

EmptyList class
	instanceVariableNames: ''!

!EmptyList class methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
new
    ^self basicNew! !


Parser subclass: #LParser
	instanceVariableNames: 'prologMethodSelector prologMethodArgument cuts temporaries statements cascadeMessages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Compiler'!
!LParser commentStamp: 'bolot 12/13/2002 15:14' prior: 0!
RE: safeGuardReturnBlock
Makes sure that the method returns, even if no match occurs.

RE: queryUndefined
Disabled for Prolog methods (because undefined Prolog variables are unbounds).

RE: prologMethodSelector
Can be used to determine if this is a smalltalk method or prolog method.

RE: Smalltalk guys
Strings, symbols, numbers, and literal points (45@65) are recognized.

RE: evaluation
Support for nicer, more Prolog-like syntax for evaluation is done through direct use of LCompiler.
Example: LCompiler evaluate: 'Family new :? father(''John'', x).'
(see Family comment for current situation)

This class and other related classes in this category were originally written by or are based on the work by Mike Teng <miket@objectshare.com>, then at Digitalk, as part of the Prolog/V implementation distributed with Smalltalk V/286 in 1988.
We gratefully acknowledge Mike's permission to port his code to Squeak.

The port to Squeak is the work of Bolot Kerimbaev <bolot@cc.gatech.edu>, a summer intern at Walt Disney Imagineering.!


!LParser methodsFor: 'expression types' stamp: 'bolot 8/5/1999 19:13'!
messagePart: level repeat: repeat
	"bolot 8/5/1999 18:14"
	"This is the same as Parser>>messagePart:repeat:"
	"with only ONE addition: support for #:? for calling Prolog stuff"

	| start receiver selector args precedence words keywordStart |
	[receiver _ parseNode.
	(hereType == #keyword and: [level >= 3])
		ifTrue: 
			[start _ self startOfNextToken.
			selector _ WriteStream on: (String new: 32).
			args _ OrderedCollection new.
			words _ OrderedCollection new.
			[hereType == #keyword]
				whileTrue: 
					[keywordStart _ self startOfNextToken + requestorOffset.
					selector nextPutAll: self advance.
					words addLast: (keywordStart to: self endOfLastToken + requestorOffset).
					self primaryExpression ifFalse: [^self expected: 'Argument'].
					self messagePart: 2 repeat: true.
					args addLast: parseNode].
			(Symbol hasInterned: selector contents ifTrue: [ :sym | selector _ sym])
				ifFalse: [ selector _ self correctSelector: selector contents
										wordIntervals: words
										exprInterval: (start to: self endOfLastToken)
										ifAbort: [ ^ self fail ] ].
			precedence _ 3]
		ifFalse: [((hereType == #binary or: [hereType == #verticalBar])
				and: [level >= 2])
				ifTrue: 
					[start _ self startOfNextToken.
					selector _ self advance asSymbol.
					self primaryExpression ifFalse: [^self expected: 'Argument'].
					self messagePart: 1 repeat: true.
					args _ Array with: parseNode.
					precedence _ 2]
				ifFalse: [hereType == #word
						ifTrue: 
							[start _ self startOfNextToken.
							selector _ self advance.
							args _ #().
							words _ OrderedCollection with:
									(start + requestorOffset to: self endOfLastToken + requestorOffset).
							(Symbol hasInterned: selector ifTrue: [ :sym | selector _ sym])
								ifFalse: [ selector _ self correctSelector: selector
													wordIntervals: words
													exprInterval: (start to: self endOfLastToken)
													ifAbort: [ ^ self fail ] ].
							precedence _ 1]
						ifFalse: [(self match: #colonQuestion)
								ifTrue: [selector _ #inferSmalltalk:var:.
										"change typeTable for Prologging"
										typeTable at: $, asciiValue put: #comma;
											at: $!! asciiValue put: #exclamationMark.
										args _ Array with: (self goalSeries) with: (encoder encodeLiteral: #inka).
										"restore typeTable for Smalltalking"
										typeTable at: $, asciiValue put: (TypeTable at: $, asciiValue);
											at: $!! asciiValue put: (TypeTable at: $!! asciiValue).
										precedence _ 3 "TODO: pick right precedence"]
								ifFalse: [^args notNil]]]].
	parseNode _ MessageNode new
				receiver: receiver
				selector: selector
				arguments: args
				precedence: precedence
				from: encoder
				sourceRange: (start to: self endOfLastToken).
	repeat]
		whileTrue: [].
	^true! !

!LParser methodsFor: 'expression types' stamp: 'bolot 8/5/1999 20:31'!
method: doit context: ctxt

	| sap blk prim messageComment methodNode |
	"need temporaries/statements in doits - to enable unbounds"
	temporaries _ OrderedCollection new.
	statements _ OrderedCollection new.
	"may need to change (temporarily) for doits"
	typeTable _ typeTable copy.

	"check if it's a Prolog method definition"
	((doit not and: [hereType == #word]) and: [tokenType == #leftParenthesis])
		ifTrue:
			[^self prologMethod: doit context: ctxt].

	sap _ self pattern: doit inContext: ctxt.
	"sap={selector, arguments, precedence}"
	(sap at: 2) do: [:argNode | argNode isArg: true].
	temporaries _ self temporaries asOrderedCollection.

	messageComment _ currentComment.
	currentComment _ nil.
	prim _ doit ifTrue: [0] ifFalse: [self primitive].
	self statements: #() innerBlock: doit.

	parseNode statements: statements , parseNode statements.

	blk _ parseNode.
	doit ifTrue: [blk returnLast]
		ifFalse: [blk returnSelfIfNoOther].
	hereType == #doIt ifFalse: [^self expected: 'Nothing more'].
	self interactive ifTrue: [self removeUnusedTemps].

	methodNode _ MethodNode new comment: messageComment.
	^methodNode
		selector: (sap at: 1)
		arguments: (sap at: 2)
		precedence: (sap at: 3)
		temporaries: temporaries
		block: blk
		encoder: encoder
		primitive: prim! !

!LParser methodsFor: 'expression types' stamp: 'spfa 6/8/2008 21:20'!
method: doit context: ctxt encoder: encoderToUse

    | sap blk prim messageComment methodNode |
    encoder _ encoderToUse.
    "need temporaries/statements in doits - to enable unbounds"
    temporaries _ OrderedCollection new.
    statements _ OrderedCollection new.
    "may need to change (temporarily) for doits"
    typeTable _ typeTable copy.

    "check if it's a Prolog method definition"
	((doit not and: [here beginsWith: Logic prologKeyword]) and: [(here last == $:) not])
        ifTrue:
            [^self prologMethod: doit context: ctxt].

    sap _ self pattern: doit inContext: ctxt.
    "sap={selector, arguments, precedence}"
    (sap at: 2) do: [:argNode | argNode isArg: true].
    temporaries _ self temporaries asOrderedCollection.

    messageComment _ currentComment.
    currentComment _ nil.
    prim _ doit ifTrue: [0] ifFalse: [self primitive].
    self statements: #() innerBlock: doit.

    parseNode statements: statements , parseNode statements.

    blk _ parseNode.
    doit ifTrue: [blk returnLast]
        ifFalse: [blk returnSelfIfNoOther].
    hereType == #doIt ifFalse: [^self expected: 'Nothing more'].
    self interactive ifTrue: [self removeUnusedTemps].

    methodNode _ self newMethodNode comment: messageComment.
    ^methodNode
        selector: (sap at: 1)
        arguments: (sap at: 2)
        precedence: (sap at: 3)
        temporaries: temporaries
        block: blk
        encoder: encoder
        primitive: prim! !

!LParser methodsFor: 'expression types' stamp: 'spfa 6/8/2008 18:47'!
prologMethod: doit context: ctxt

	| blk messageComment methodNode blockComment |

	prologMethodSelector _ (self pattern: doit inContext: ctxt) first.
"	prologMethodSelector _ ((actualSelector
							allButFirst: 'clause' size) withFirstCharacterDownshifted, ':') asSymbol."

"	prologMethodSelector _ (here, ':') asSymbol.
"


	typeTable at: $, asciiValue put: #comma.
	typeTable at: $!! asciiValue put: #exclamationMark.

	(prologMethodArgument _ encoder bindArg: #assoc) isArg: true.
	messageComment _ currentComment.
	currentComment _ nil.
	" self statements: #() innerBlock: doit. "
	parseNode _ BlockNode new
				arguments: #()
				statements: (self ruleSeries, self safeGuardReturnStatements)
				returns: doit
				from: encoder.
	blockComment _ currentComment.
	currentComment _ nil.
	parseNode comment: blockComment.
	blk _ parseNode.
	hereType == #doIt ifFalse: [^self expected: 'Nothing more'].
	methodNode _ MethodNode new comment: messageComment.

	^methodNode
		selector: prologMethodSelector
		arguments: (OrderedCollection with: prologMethodArgument)
		precedence: 3
		temporaries: temporaries
		block: blk
		encoder: encoder
		primitive: 0! !


!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 22:15'!
addTemp: aTerm
	"Decide whether aTerm should be
	declared as a temporay."
	| var |

	var _ encoder encodeVariable: aTerm asString
		ifUnknown: [encoder bindTemp: aTerm asString].

	(#('true' 'false' 'nil' 'super' 'self') includes:
		aTerm asString) ifTrue: [^var].
	(aTerm asString at: 1) isLowercase ifFalse: [^var].
	temporaries do: [:i |
		i = aTerm ifTrue: [^var]].
	temporaries add: aTerm.
	statements addFirst: (
		AssignmentNode new
			variable: var
			value: (self send: #new
					to: 'LogicRef'
					with: #())).
	^var! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 16:58'!
argumentList: aList
	^(aList isKindOf: List)
		ifTrue: [self arguments: aList]
		ifFalse: [aList]! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/4/1999 18:14'!
arguments: aList
	"Answer a MessageNode for predicate
	arguments."
	| receiver bList |
	aList isEmpty  "zero argument"
		ifTrue: [^self nilList].
	receiver _
		self send: #with:
			to: ((aList isKindOf: Relation)
				ifTrue: ['Relation']
				ifFalse: ['List'])
			with: (Array with:
				(self argumentList: aList head)).
	aList isLastNode  "single argument or [x | y]"
		ifTrue: [
			aList tail = self nilList
				ifTrue: [^receiver]
				ifFalse: [
					receiver _
						self sendCascade: #addList:
							to: receiver
							with: (Array with:
								(self argumentList: aList tail)).
					^self send: #yourself
						to: receiver
						with: #()]].
	"more than one arguments"
	bList _ aList tail.
	[receiver _
		self sendCascade: #add:
			to: receiver
			with: (Array with:
				(self argumentList: bList head)).
	bList _ bList tail.
 	(bList isKindOf: List)
		ifTrue: [bList isEmpty]
		ifFalse: [receiver _
			self sendCascade: #addList:
				to: receiver
				with: (Array with:
					(self argumentList: bList)).
			true]]
	whileFalse: [].
	^self send: #yourself
		to: receiver
		with: #()! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/4/1999 02:02'!
buildBlock
	(self match: #colonDash)
		ifTrue: [^self predicateSeries]
		ifFalse: [^self send: #value to: prologMethodArgument with: #()]! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 12/13/2002 16:16'!
emptyList
	^self send: #new to: 'EmptyList' with: #()! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/5/1999 19:09'!
goalSeries
	"Do the work for method statements by
	 adding each goal to statements."
	" (Prolog new :? goal1(x,y), goal2(z,y)) do: [:i | ...] "
	| aList expression |
	aList _ List new.
	[expression _ self predicate.
	aList add: expression.
	(self match: #comma)]
		whileTrue: [].
	^self goalSeries: aList! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/5/1999 19:06'!
goalSeriesList: aList
	^(aList isKindOf: List)
		ifTrue: [self goalSeries: aList]
		ifFalse: [aList]! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/5/1999 19:09'!
goalSeries: aList
	"Do the work for method statements by
	 adding each goal to statements."
	"Return a MessageNode"
	" (Prolog new :? goal1(x,y), goal2(z,y)) do: [:i | ...] "

	| receiver bList |
	aList isEmpty  "zero argument"
		ifTrue: [^self nilList].
	receiver _
		self send: #with:
			to: ((aList isKindOf: Relation)
				ifTrue: ['Relation']
				ifFalse: ['List'])
			with: (Array with:
				(self goalSeriesList: aList head)).
	aList isLastNode  "single argument or [x | y]"
		ifTrue: [
			aList tail = self nilList
				ifTrue: [^receiver]
				ifFalse: [
					receiver _
						self sendCascade: #addList:
							to: receiver
							with: (Array with:
								(self goalSeriesList: aList tail)).
					^self send: #yourself
						to: receiver
						with: #()]].
	"more than one arguments"
	bList _ aList tail.
	[receiver _
		self sendCascade: #add:
			to: receiver
			with: (Array with:
				(self goalSeriesList: bList head)).
	bList _ bList tail.
 	(bList isKindOf: List)
		ifTrue: [bList isEmpty]
		ifFalse: [receiver _
			self sendCascade: #addList:
				to: receiver
				with: (Array with:
					(self goalSeriesList: bList)).
			true]]
	whileFalse: [].
	^self send: #yourself
		to: receiver
		with: #()! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 17:04'!
listTerms
	"Answer a list of predicate terms."
	| term aList |
	self advance.
	(self match: #rightBracket)
		ifTrue: [
			^self emptyList].
	term _ self term.
	aList _ List with: term.
	[true] whileTrue: [
		(self match: #verticalBar)
			ifTrue: [
				aList addList: self term.
				(self match: #rightBracket)
					ifTrue: [
						^aList]
					ifFalse: [self expected: 'Right bracket']].
	(self match: #comma)
		ifTrue: [aList add: self term]
		ifFalse: [
			(self match: #rightBracket)
				ifTrue: [^aList]
				ifFalse: [self expected: 'Right bracket']]]! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 21:22'!
nilList
	^self send: #new to: 'EmptyList' with: #()! !

!LParser methodsFor: 'prolog parser' stamp: 'spfa 6/8/2008 22:23'!
predCut
	cuts _ 1.
	^List with: #primlogicCut: with: (self returnBlock: (encoder encodeVariable: 'self'))

	"^List with:
		(SelectorNode new
			position: token position;
			value: #primlogicCut:)
		with:
			(self returnBlock:
			(VariableNode new
				value: 'self'))"! !

!LParser methodsFor: 'prolog parser' stamp: 'spfa 6/8/2008 23:02'!
predicate
	| result pred |
	(((hereType == #period) or: [
	hereType == #comma]) or: [hereType == #doIt])
		ifTrue: [self expected: 'Predicate'].
	(self match: #exclamationMark)
		ifTrue: [^self predCut].
	hereType == #word
		ifFalse: [self notify: 'illegal predicate name'].
	pred _ here asString.

	result _ Relation with: (Logic selectorForPredicate: pred).

	self advance.
	" must be '(' or binary predicate "
	(self match: #leftParenthesis)
		ifFalse: [self expected: 'Left parenthesis for predicate'].
	(pred = 'is' or: [pred = 'consult'])
		ifTrue: [self predSmalltalk: result] "special cases"
		ifFalse: [
			(self match: #rightParenthesis)
				ifFalse: [
					self terms: result.
					(self match: #rightParenthesis)
						ifFalse: [self expected: 'Right parenthesis']]].
	^result! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 22:01'!
predicateSeries
	| pred |
	pred _ self predicate.
    ^BlockNode new
		arguments: OrderedCollection new
		statements: (OrderedCollection with: (
			self
				send: pred head
				to: 'self'
				with: (Array with: (self send: #key:value:
						to: 'Association'
						with: (Array
							with: (self arguments: pred tail)
							with:
								((self match: #comma)
									ifTrue: [self predicateSeries]
									ifFalse:[self
										send: #value
										to: prologMethodArgument
										with: #()]))))))
		returns: false
		from: encoder! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/5/1999 17:12'!
predSmalltalk: result
	"Process predicate with a Prolog
	and a Smalltalk term."
	| expression |
	result add: (self term).
	(self match: #comma)
		ifFalse: [self expected: 'Term (comma?)'].
	self expression
		ifFalse: [self expected: 'Expression'].
	expression _ parseNode.
    (self match: #rightParenthesis)
		ifFalse: [self expected: 'Right parenthesis'].
	result add:
		(BlockNode new
			arguments: #()
			statements: (OrderedCollection with: expression)
			returns: false
			from: encoder).! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/14/1999 15:11'!
returnBlock: anExpression
	"Answer a Block which returns anExpression."

	^BlockNode new
		arguments: #()
		statements: (OrderedCollection with:
			(ReturnNode new
				expr: anExpression
				encoder: encoder
				sourceRange: (1 to: 1)))
		returns: true
		from: encoder! !

!LParser methodsFor: 'prolog parser' stamp: 'spfa 6/8/2008 22:33'!
rule
	"rule:
		predicate [:- predicates] "
	| predicate headArg block |
	cuts _ nil.
	predicate _ self predicate.
	predicate head == prologMethodSelector
		ifFalse: [self notify: 'predicate name different'].
	headArg _ self arguments: predicate tail.
	block _ self buildBlock.
	(self match: #period)
		ifFalse: [self expected: 'Period'].
	(hereType == #doIt and: [cuts isNil])
		ifTrue: [ "optimize the stack"
			^self send: #unify:with:then:
				to: 'self'
				with: (OrderedCollection
					with: (self send: #key to: prologMethodArgument with: #())
					with: headArg
					with: (self returnBlock: block))]
		ifFalse: [
			^self send: #unify:with:then:
				to: 'self'
				with: (OrderedCollection
					with: (self send: 'key' to: prologMethodArgument with: #())
					with: headArg
					with: block)]! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 18:31'!
ruleSeries
	"Do the work for method statements by
	 adding each rule to statements."
	| expression |
	[expression _ self rule.
	statements add: expression.
	source atEnd]
		whileFalse: [].
	^statements! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/14/1999 14:23'!
safeGuardReturnStatements
	^OrderedCollection
		with: (self send: #ifTrue:ifFalse: to: (self send: #isEmptyOrNil to: 'answer' with: #())
				with: (Array with: (self returnBlock: (encoder encodeVariable: 'nil'))
						with: (self returnBlock: (self send: #asArray to: 'answer' with: #()))))
	"self unbindVar: 0.
	answer isEmptyOrNil
		ifTrue: [^nil]
		ifFalse: [^answer asArray]"

	"answer ifNil: [^nil].
	answer size = 0 ifTrue: [^nil].
	^answer asArray"! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/14/1999 15:10'!
sendCascade: selector to: receiver with: arguments
	"selector is a Symbol. receiver is a Node."
	| argNodes cascadeReceiver |

	cascadeMessages isNil
		ifTrue: [cascadeMessages _ Dictionary new].
	(cascadeMessages includesKey: receiver)
		ifFalse: [cascadeMessages at: receiver put: OrderedCollection new].

	argNodes _ arguments collect: [:elem |
		(elem isKindOf: ParseNode)
			ifTrue: [elem]
			ifFalse: [encoder encodeLiteral: elem]].

	(cascadeMessages at: receiver)
		add: (cascadeReceiver _ MessageNode new receiver: nil
				selector: selector
				arguments: argNodes
				precedence: 3
				from: encoder
				sourceRange: (1 to: 1)).
	^receiver! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/14/1999 15:10'!
send: selector to: receiver with: arguments
	"selector is a Symbol or a Selector
	node. receiver can be
	either a String or other nodes."
	| receiverNode argNodes |
	receiverNode _  (receiver isKindOf: String)
						ifTrue: [encoder encodeVariable: receiver]
						ifFalse: [receiver].

	argNodes _ arguments collect: [:elem |
		(elem isKindOf: ParseNode)
			ifTrue: [elem]
			ifFalse: [encoder encodeLiteral: elem]].

	(cascadeMessages isNil or: [(cascadeMessages includesKey: receiver) not])
		ifTrue: [^MessageNode new
				receiver: receiverNode
				selector: (selector asSymbol)
				arguments: argNodes
				precedence: 3
				from: encoder
				sourceRange: (1 to: 1)]
		ifFalse: [(cascadeMessages at: receiver)
					add: (MessageNode new
					receiver: nil
					selector: (selector asSymbol)
					arguments: argNodes
					precedence: 3
					from: encoder
					sourceRange: (1 to: 1)).
				^CascadeNode new
				receiver: receiverNode
				messages: (cascadeMessages removeKey: receiver)]! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 19:15'!
structure: aSymbol
	"Process the argument part of a structure
	 whose functor is aSymbol. Current token
	 is now the left paren. Answer a Relation
	 representing the structure."
	| result |
	result _ Relation with: aSymbol.
	"self advance."
	(self match: #rightParenthesis)
		ifFalse: [
			self terms: result.
			(self match: #rightParenthesis)
				ifFalse: [self expected: 'Right parenthesis']].
	^result! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/14/1999 15:24'!
term
	| result |
	((hereType == #rightParenthesis) or: [hereType == #comma])
		ifTrue: [self expected: 'Term'].
	(hereType == #leftBracket)
		ifTrue: [^self listTerms].
	(self match: #leftParenthesis)
		ifTrue: [^self structure: #and].
	result _ here.
	(hereType == #number and: [token == #@])
		ifTrue:
			[self advance; advance.
			result _ result @ here.
			self advance.
			^result].
	(hereType == #string or: [hereType == #number or: [hereType == #literal]])
		ifTrue: 
			[self advance.
			^result].
	hereType == #word
		ifFalse: [
			(self match: #leftArrow) "should be #underscore"
				ifTrue: [^self send: #new to: 'LogicDontCare' with: #()]
				ifFalse: [self notify: 'illegal term']].
	self advance.
	(self match: #leftParenthesis)
		ifTrue: [^self structure: result asSymbol]
		ifFalse: [^self addTemp: result]! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 22:01'!
terms: aList
        "Answer a list of predicate terms."
    | term |
    term _ self term.
    aList add: term.
    (self match: #comma)
        ifTrue: [self terms: aList]! !


!LParser methodsFor: 'error correction' stamp: 'bolot 8/4/1999 18:24'!
queryUndefined
	"a lot of Prolog variables are undefined because they are unbound"
	"let's prevent unnecessary interrogation (unless it's a Smalltalk method)"
	prologMethodSelector ifNil: [^super queryUndefined]! !


!LParser methodsFor: 'multi-character scans' stamp: 'bolot 7/6/1999 21:39'!
xColon		"process prolog :- and :? symbols"
	aheadChar = $- ifTrue:
		[self step.
		tokenType _ #colonDash.
		self step.
		^ token _ #colonDash].
	aheadChar = $? ifTrue:
		[self step.
		tokenType _ #colonQuestion.
		self step.
		^ token _ #colonQuestion].
	^super xColon! !


!LParser methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 22:35'!
primitive

	"ugly hack for 3.8 -> 3.10 compatibility"

	^ [self pragmaPrimitives] on: Error do: [super primitive]! !


List subclass: #Relation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Compiler'!

!Relation methodsFor: 'adding' stamp: 'mt 6/28/1999 12:00'!
add: anObject
    (content isNil and: [link isNil])
        ifTrue: [
            content := anObject.
            link := EmptyList new]
        ifFalse: [super add: anObject].
    ^anObject! !


!Relation methodsFor: 'printing' stamp: 'mt 6/28/1999 12:00'!
printOn: aStream
    content printOn: aStream.
    aStream nextPut: $(.
    (link isKindOf: List)
        ifTrue: [link printOne: aStream]
        ifFalse: [link printOn: aStream].
    aStream nextPut: $)! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Relation class
	instanceVariableNames: ''!

!Relation class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
new
    ^super basicNew! !
