Object subclass: #DogStep
	instanceVariableNames: 'destination speed forwardDirection isAbsolute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Dungeon'!

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:19'!
defaultHopSpeed
	^15! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:19'!
defaultSpeed
	^15! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:15'!
fall: aHeight
	"relative"
	self fall: aHeight from: 0@0.
	isAbsolute _ false.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:15'!
fall: aHeight from: aStartPoint
	"relative"
	destination _ aStartPoint + (0@aHeight).
	speed _ self defaultHopSpeed.
	forwardDirection _ 180.
	isAbsolute _ true.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:46'!
getDestination
	^destination! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:45'!
getForwardDirection
	^forwardDirection! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:45'!
getSpeed
	^speed! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:12'!
goto: aPoint
	"absolute"
	destination _ aPoint.
	speed _ self defaultSpeed.
	forwardDirection _ 90.
	isAbsolute _ true.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:42'!
goto: aPoint speed: aSpeed
	"absolute"
	destination _ aPoint.
	speed _ aSpeed.
	forwardDirection _ 90.
	isAbsolute _ true.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:12'!
go: aPoint
	"relative"
	destination _ aPoint.
	speed _ self defaultSpeed.
	forwardDirection _ 90.
	isAbsolute _ false.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:37'!
isAbsolute
	^isAbsolute == true! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:15'!
jump: aHeight
	"relative"
	self jump: aHeight from: 0@0.
	isAbsolute _ false.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:15'!
jump: aHeight from: aStartPoint
	"relative"
	destination _ aStartPoint - (0@aHeight).
	speed _ self defaultHopSpeed.
	forwardDirection _ 0.
	isAbsolute _ true.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DogStep class
	instanceVariableNames: ''!

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:41'!
fall: aHeight
	^self new fall: aHeight; yourself! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 18:03'!
fall: aHeight from: aStartPoint
	^self new fall: aHeight from: aStartPoint; yourself! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:41'!
goto: aPoint
	^self new goto: aPoint; yourself! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:43'!
goto: aPoint speed: aSpeed
	^self new goto: aPoint speed: aSpeed; yourself! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:42'!
go: aPoint
	^self new go: aPoint; yourself! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:41'!
jump: aHeight
	^self new jump: aHeight; yourself! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 18:03'!
jump: aHeight from: aStartPoint
	^self new jump: aHeight from: aStartPoint; yourself! !


Prolog subclass: #Dungeon
	instanceVariableNames: 'pen aspect snoopy delay arcs nodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Dungeon'!
!Dungeon commentStamp: 'bolot 12/13/2002 16:00' prior: 0!
Incomplete

ISSUE: Animation
Smalltalk/V uses a slightly different approach.
We'll either adopt it, or use Morphic.

ISSUE: Stack size limit
A few methods didn't compile (and have big portions commented out)

ISSUE: Bugs
An ongoing attempt to rewrite this example is incomplete.
!


!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 21:25'!
logicAdjust

"Adjust the y coordinate by Aspect ratio."
adjust(result, y) :-
    is(result, (y value * aspect) truncated).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 22:24'!
logicAvoid

"Fail if room is one of roomsToAvoid and
 go back to previousRoom. Else succeed."
avoid(room,roomsToAvoid,previousRoom) :-
	member(room,roomsToAvoid),
	goto(previousRoom), !!, fail().
avoid(_,_,_).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 21:25'!
logicDraw

"Draw a map of the dungeon."
draw() :- drawArc(), fail().
draw() :- drawNode(), fail().
draw(). ! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 22:47'!
logicDrawArc

drawArc() :- gallery(x, y),
	position(x, a, b),
	position(y, c, d),
	is(_, arcs add: (PolygonMorph vertices: {a value @ b value. c value @ d value}
			color: Color black borderWidth: 2 borderColor: Color black)),
	is(_, World addMorph: arcs last behind: snoopy).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 22:48'!
logicDrawNode

"Call a Smalltalk method to draw a room."
drawNode() :-
	position(x, a, b),
	"is(_, x value displayAt: a value @ b value),"
	is(_, nodes add: (SimpleButtonMorph new label: x value)),
	is(_, nodes last position: a value-20 @ (b value-10)),
	is(_, World addMorph: nodes last behind: snoopy).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 21:26'!
logicGallery

"Define database of all connecting rooms."
gallery(#entry,#monsters).
gallery(#entry,#stadium).
gallery(#stadium,#hell).
gallery(#stadium,#dolphin).
gallery(#stadium,#pond).
gallery(#exit,#gold).
gallery(#robbers,#gold).
gallery(#stadium,#robbers).
gallery(#pond,#gold).
gallery(#dolphin,#exit).
gallery(#monsters,#gold).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 22:49'!
logicGo

"Move from a room here to a room there."
go() :-
	initialize(),
	draw(),
	"is(_, self halt),"
	route(#entry,#exit,[#entry]).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 22:47'!
logicGoto

goto(nextRoom) :-
	position(nextRoom, x, y),
	is(_, snoopy goto: x value @ (y value)).
	"is(_, snoopy position: x value - 30 @ (y value - 25)),"
	"is(_, Transcript show: '')," "to force morphs to appear"
	"is(_, delay wait)."! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 21:26'!
logicGotoAndAvoid

gotoAndAvoid(room,roomsToAvoid,previousRoom) :-
	goto(room),
	avoid(room,roomsToAvoid,previousRoom).
gotoAndAvoid(_,_,_).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 22:24'!
logicIsFinished

"Check if adventure is succeeded."
isFinished(visitedRooms) :-
	member(#gold,visitedRooms),
	end().
isFinished([_, x | _]) :-
	goto(x), !!, fail().! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 21:27'!
logicMember

"Succeed if the first argument is a
 member of a List in the second argument."
member(x,[x | _]).
member(x,[_ | h]) :- member (x,h).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 23:04'!
logicNeighborroom

"Unify the next neighbor room of x with y."
neighborroom(x,y,visitedRooms) :-
	or(gallery(x,y), gallery(y,x)).
neighborroom(_,_,[_ , x | _]) :-
	goto(x), !!, fail().! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 21:27'!
logicPosition

"Define the position of each room on screen."
position(#entry,40,y) :- adjust(y, 80).
position(#stadium,230,y) :- adjust(y, 50).
position(#monsters,40,y) :- adjust(y, 200).
position(#hell,90,y) :- adjust(y, 310).
position(#pond,330,y) :- adjust(y, 160).
position(#gold,460,y) :- adjust(y, 200).
position(#dolphin,380,y) :- adjust(y, 70).
position(#robbers,230,y) :- adjust(y, 310).
position(#exit,580,y) :- adjust(y, 180).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 21:27'!
logicPosition2

"Define the position of each room on screen."
position2(#entry,40@80).
position2(#stadium,230@50).
position2(#monsters,40@200).
position2(#hell,90@310).
position2(#pond,330@160).
position2(#gold,460@200).
position2(#dolphin,380@70).
position2(#robbers,230@310).
position2(#exit,580@180).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 22:50'!
logicRoute

"Find the route to the next room avoiding
 dangerous or visited rooms."
route(#exit,#exit,visitedRooms) :-
	isFinished(visitedRooms).
route(#exit,_,_).
route(room,wayOut,visitedRooms) :-
	not(eq(room, #exit)),
	neighborroom(room,nextRoom,visitedRooms),
	not(member(nextRoom,visitedRooms)),
	goto(nextRoom),
	avoid(nextRoom,[#monsters, #robbers],room),
	route(nextRoom,wayOut,[nextRoom|visitedRooms]).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 22:48'!
primlogicEnd: assoc
	"End the whole thing.  This method
	does not return.  It restarts the Scheduler."
	3 timesRepeat: [snoopy hop: 100].
	snoopy go: 100@0.
	snoopy go: -200@0.
	snoopy go: 100@0.
	PopUpMenu notify: 'Click OK when animation is over'.
	snoopy delete.
	snoopy _ nil.
	arcs , nodes do: [:morph | morph delete].
	arcs _ nodes _ nil.
	Display restore.
	'The End' halt: 'Gold is found, close this window'.
	"Scheduler resume"! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 22:47'!
primlogicInitialize: assoc
	"This is a Smalltalk method, but can be called as
	a Prolog/V predicate.  It initializes instance
	variables and gray the screen.  The animal moving
	speed is also initialized here."

	snoopy _ WanderingDogMorph newSnoopyDog.
	snoopy openInWorld.
	arcs _ OrderedCollection new.
	nodes _ OrderedCollection new.
	"delay _ Delay forSeconds: 1."
	"pen _ PenPointRecorder new defaultNib: 2."
	aspect _ 1.
	^assoc value! !


PolygonMorph subclass: #WanderingDogMorph
	instanceVariableNames: 'destinations speed stepTime lastDestination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Dungeon'!
!WanderingDogMorph commentStamp: 'bolot 12/15/2002 03:13' prior: 0!
WanderingDogMorph - used for animating Dungeons demo



self openInWorld
self stop
self start
self position: 10@100
self position
self addFlexShellIfNecessary 
self owner position
self position: 10@10
self goto: 300@500
self owner delete
self stepTime: 100
TransformationMorph 
self player
moveToward:
self isFlexed 
self referencePosition bearingToPoint: 10@100
self referencePosition
!


!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 02:33'!
addDestination: aPoint
	destinations add: aPoint.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 03:23'!
delete
	| currOwner |
	self isFlexed
		ifTrue: [currOwner _ self owner. super delete. currOwner delete]
		ifFalse: [super delete].! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:05'!
fall: aHeight
	| lastStep |
	lastStep _ destinations isEmpty ifTrue: [lastDestination] ifFalse: [destinations last].
	self addDestination: (DogStep fall: aHeight from: lastStep getDestination)! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 02:33'!
getSpeed
	^speed! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:42'!
goto: aPoint
"Transcript show: 'going to: ', aPoint asString; cr."
	self addDestination: (DogStep goto: aPoint)! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:43'!
goto: aPoint speed: aNumber
"Transcript show: 'going to: ', aPoint asString; cr."
	self addDestination: (DogStep goto: aPoint speed: aNumber)! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:18'!
go: aPoint
	| lastStep |
	lastStep _ destinations isEmpty ifTrue: [lastDestination] ifFalse: [destinations last].
	self addDestination: (DogStep goto: aPoint + lastStep getDestination)! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:50'!
hop: aHeight
	self jump: aHeight.
	self fall: aHeight.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:48'!
initialize
	super initialize.
	destinations _ OrderedCollection new.
	Player new costume: self.
	speed _ 5.
	lastDestination _ DogStep goto: self position.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:04'!
jump: aHeight
	| lastStep |
	lastStep _ destinations isEmpty ifTrue: [lastDestination] ifFalse: [destinations last].
	self addDestination: (DogStep jump: aHeight from: lastStep getDestination)! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:12'!
setSpeed: aNumber
	speed _ aNumber! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:20'!
step
	| nextPoint nextStep angle alterEgo |
	super step.
	destinations isEmptyOrNil ifTrue: [^self].
	nextStep _ destinations first.
	self setSpeed: nextStep getSpeed.
	nextPoint _ nextStep getDestination.
	nextStep isAbsolute ifFalse: [nextPoint _ nextPoint + lastDestination getDestination].
	"nextStep getForwardDirection = self forwardDirection
		ifFalse: [self forwardDirection: nextStep getForwardDirection]."

	self isFlexed ifTrue: [alterEgo _ self owner] ifFalse: [alterEgo _ self].
	"alterEgo _ self owner."

	((alterEgo referencePosition - nextPoint) r < (2*self getSpeed))
		ifTrue: [lastDestination _ destinations removeFirst].
	angle _ alterEgo referencePosition bearingToPoint: nextPoint.
	self player setHeading: angle.
	self player forward: self getSpeed.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 02:47'!
stop
	super stop.
	destinations _ OrderedCollection new! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

WanderingDogMorph class
	instanceVariableNames: ''!

!WanderingDogMorph class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:00'!
dogShapeVertices
	"this is a large dog, use (array/4) rounded to get a smaller one"
	^{195@30. 237@44. 230@61. 200@56. 212@72. 188@63. 171@101. 184@162. 150@111. 120@172. 126@107. 46@110. 56@165. 30@124. 0@159. 18@64. 7@4. 35@48. 141@51. 170@18. 173@0. 181@11. 195@2. 195@30}! !

!WanderingDogMorph class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:24'!
newSnoopyDog
	^self new
		vertices: (self dogShapeVertices / 4) rounded
			color: Color white
			borderWidth: 2 borderColor: Color black;
		makeClosed;
		setSpeed: 10;
		forwardDirection: 90;
		yourself! !
